# ifndef __BALTAZAR__
///////////////////////////////////
//
//  Baltazar v5.00
//  (c)1995,1996,1997 SGP Systems
//
//
# define __BALTAZAR_VERSION__ 500 // v5.00

# pragma idchars = "젡Ԝ֐қՄӚш"

typedef long TypPedmt; // v4.00

// datum
typedef struct {
  int  Rok;   // 1980-2099
  unsigned char
    Msc,    // 1-12
    Den,      // 1-28,29,30,31
    DenTdne; // 0-6; 0=nedle, 1=pondl...
  } TypDatum;

// as
typedef struct {
  unsigned char Hodiny, Minuty, Sekundy, Setiny;
  } Typas;

built_in(  3) void VytvoProstor();
built_in(  4) void ZruProstor();
built_in( 26) int  UloScnu( char* jmno );
built_in( 27) int  NatiScnu( char* jmno );
built_in( 11) int  RychlostBaltazara( unsigned rychlost );
built_in(  5) void Popojdi( int pocet_policek );
built_in(  6) void ekej( int zpozdeni );
built_in(  7) void VpravoVbok();
built_in(  8) void VlevoVbok();
built_in( 15) void Neviditeln();
built_in( 16) void Viditeln();
built_in(  9) int  NastavBarvuarovn( int barva );
built_in( 10) void aruj( TypPedmt predmet );
built_in( 17) void Nhodnجaruj( TypPedmt predmet );
built_in( 41) void arujNaPozici( TypPedmt predmet, int x, int y );
built_in( 39) void BezOblku();
built_in( 40) void SOblkem();

built_in( 25) int  tiKlvesuZFronty();
built_in( 65) void VyprzdniFrontuKlves();
built_in( 57) int  BylaStisknutaKlvesa();
# define           tiKlvesuZFrontySeknm() (ekej(NaKlvesu),tiKlvesuZFronty())
# define           tiKlvesuSeknm()        (VyprzdniFrontuKlves(),ekej(NaKlvesu),tiKlvesuZFronty())
# define           ekejNaKlvesu()            (VyprzdniFrontuKlves(),ekej(NaKlvesu))
built_in(315) int  tiKlvesuSeknm2( int as, int Klvesa );

built_in( 28) void PepniNaText();
built_in( 29) void PepniNaBaltazara();

built_in( 76) void EscMnus();
built_in( 75) void EscPlus();

built_in( 12) int  SmrBaltazara();
built_in( 18) int  PoziceBaltazaraX();
built_in( 19) int  PoziceBaltazaraY();
built_in( 13) TypPedmt PedmtPedB();
built_in( 14) int  BarvatvercePedB();
built_in( 20) int  PrchodnostPedmtuPedB();
built_in( 21) int  VzdlenostPedmtuPedB( TypPedmt predmet );
built_in( 22) int  VzdlenosttvercePedB( int barva );
built_in( 23) int  VzdlenostPekkyPedB();
built_in( 24) TypPedmt NejbliPedmtPedB();

built_in(  1) int   TxttiZnak();
built_in( 34) int   TxttiCetzec( char* retezec, int max_delka );
built_in( 36) int   TxttiIslo( int& cele_cislo );
built_in( 37) int   TxttiUslo( unsigned& prirozene_cislo );
built_in( 35) int   TxttiDslo( double& realne_cislo );
built_in( 38) int   TxttiNovdek();

built_in(  0) void  TxtPiZnak( char c );
built_in( 30) char* TxtPietzec( char* retezec );
built_in( 32) int   TxtPiLslo( long d, int delka );
built_in( 33) int   TxtPiUslo( unsigned d, int delka );
built_in( 31) int   TxtPiDslo( double d, int delka, int desetinna_delka );
# define            TxtPiNovdek() (TxtPiZnak('\n'))

built_in( 64) void  GrSmaOkno();
built_in( 67) void  GrNastavPozici( int x, int y );
built_in( 69) int   GrPoziceX();
built_in( 70) int   GrPoziceY();
built_in( 68) int   GrNastavBarvuPoped( int barva );
built_in( 77) int   GrNastavBarvuPozad( int barva );
built_in( 74) void  GrPiZnak( int z );
built_in( 66) void  GrPietzec( char* text );
built_in( 72) void  GrPiLslo( long d, int delka );
built_in( 73) void  GrPiUslo( int d, int delka );
built_in( 71) void  GrPiDslo( double d, int delka, int desetinna_delka );

built_in( 58) Typas&    Systmovas( Typas& cas );
built_in( 59) TypDatum&  SystmovDatum( TypDatum& datum );

built_in( 60) void  StopkyNuluj();
built_in( 61) void  StopkyStart();
built_in( 62) void  StopkyStop();
built_in( 63) void  Stopky( Typas& cas );

built_in( 78) void  PiPort8( int port, unsigned char byte );
built_in( 79) int   tiPort8( int port );
built_in( 80) void  PiPort16( int port, int word );
built_in( 81) int   tiPort16( int port );

built_in( 45) double sqrt( double r );
built_in( 46) double sqr( double r );
built_in( 47) double atan( double r );
built_in( 48) double abs( double r );
built_in( 49) double cos( double r );
built_in( 50) double sin( double r );
built_in( 51) double exp( double r );
built_in( 52) double frac( double r );
built_in( 53) double integer( double r );
built_in( 54) double log( double r );

built_in( 42) unsigned Nhodnslo( unsigned rozsah );
built_in( 43) void     Tn( unsigned vyska );
built_in( 44) void     VypniTn();
built_in(  2) unsigned Dlkaetzce( char* s );

// makra pro cyklus # (for)
# define OdDoKrok(var,od,do,krok)            \
           (var)= (od); (var)<=(do); (var)+= (krok)
# define OdDolDoKrok(var,od,do,krok)        \
           (var)= (od); (var)>=(do); (var)-= (krok)
# define Od0(var,kolikrat)                      \
           (var)= 0; (var)<(kolikrat); ++(var)
# define DolDo0(var,kolikrat)                  \
           (var)= ((kolikrat)-1); (var)>=0; --(var)

built_in(  0) void      putchar( char c );
built_in(  1) int       getchar();
built_in(  2) unsigned  strlen( char* s );

/////////////////////////////////
//
//  main() mus mt tento tvar:
    extern void main();

///////////////
//
//  KONSTANTY
//

// pedmty
# define Okraj            0L
# define tverec        (-1L)
# define Ze              2L

// smry
# define Vchod           1
# define Jih              2
# define Zpad            3
# define Sever            4

// barvy
# define ern            0
# define Tmavozelen      1
# define Modr            2
# define Tmavomodr       3
# define Fialovorov    4
# define ervenohnd     5
# define Krmov          6
# define Svtloed       7
# define Tmavoed        8
# define Svtlozelen     9
# define Svtlomodr      10
# define Fialov          11
# define erven          12
# define Oranov         13
# define lut            14
# define Bl             15

// vzdlenost
# define Nevidm          20

// ekn
# define NaKlvesu        ((int)0x8001)
# define NaMy            ((int)0x8002)

// klvesy
# define KlNen           0
# define KlDol           0x5000
# define KlDoleva         0x4b00
# define KlDoprava        0x4d00
# define KlNahoru         0x4800
# define KlEnd            0x4f00
# define KlHome           0x4700
# define KlPageUp         0x4900
# define KlPageDown       0x5100
# define KlEsc            27
# define KlEnter          '\r'
# define KlIns            0x5200
# define KlDel            0x5300
# define KlF1             0x3b00
# define KlF2             0x3c00
# define KlF3             0x3d00
# define KlF4             0x3e00
# define KlF5             0x3f00
# define KlF6             0x4000
# define KlF7             0x4100
# define KlF8             0x4200
# define KlF9             0x4300
# define KlF10            0x4400
# define KlF11            0x8500
# define KlF12            0x8600

// przdn ukazatel
# define NULL             0

// grafick oknko
# define GrVkaZnaku                   10
# define GrkaZnaku                   8
# define GrVkaOkna                    26
# define GrkaOkna                    386

// prostor
# define kaProstoru                  15
# define VkaProstoru                  10
# define PoetPedmt                  150

# define P                             3.1415926535897932385

////////////////
//
//  verze 3.08
//

built_in( 83) TypPedmt VyberPedmt( int cisla );
built_in( 84) TypPedmt PedmtNaPozici( int x, int y );
built_in( 85) int  BarvatverceNaPozici( int x, int y );
built_in( 86) int  NastavPoziciBaltazara( int x, int y );

built_in( 87) int  TxtNastavBarvuPoped( int barva );
built_in( 88) int  TxtNastavBarvuPozad( int barva );
built_in( 89) void TxtNastavPozici( int x, int y );
built_in( 90) void TxtSmaObrazovku();

////////////////
//
//  verze 3.10
//

// makra pro cyklus # (for)
# define OdDoKrok(var,od,do,krok) \
           (var)= (od); (var)<=(do); (var)+= (krok)
# define OdDolDoKrok(var,od,do,krok) \
           (var)= (od); (var)>=(do); (var)-= (krok)
# define Od0(var,kolikrat) \
           (var)= 0; (var)<(kolikrat); ++(var)
# define DolDo0(var,kolikrat)\
           (var)= ((kolikrat)-1); (var)>=0; --(var)

built_in(105) int GrafickKarta();
# define KartaCGA   1
# define KartaEGA   3
# define KartaHerc  7
# define KartaVGA   9
# define KartaVESA 10

////////////////
//
//  verze 3.20
//

built_in(104) int  DOSProve( char* radkovy_prikaz_DOSu );
built_in(106) void GrNastavPvodnPaletu();
built_in(107) int  GrNatiPaletu( char* jmeno_souboru );
built_in(108) TypPedmt Baltedit();

////////////////
//
//  verze 3.3+
//

// nov synonyma pro testovn
# define Neplat               !
# define JeMenNe            <
# define JeMenNeboRovno      <=
# define JeVtNe            >
# define JeVtNeboRovno      >=
# define Je                    ==
# define Nen                  !=
# define ASouasn             &&
# define Nebo                  ||
# define Pravdiv              1
# define Nepravdiv            0

// barvy pro textov md
# define Txtern               0
# define TxtModr               1
# define TxtZelen              2
# define TxtModrozelen         3
# define Txterven             4
# define TxtFialov             5
# define TxtHnd               6
# define TxtSvtloed          7
# define TxtTmavoed           8
# define TxtSvtlomodr         9
# define TxtSvtlozelen       10
# define TxtSvtlomodrozelen  11
# define TxtSvtloerven      12
# define TxtSvtlofialov      13
# define Txtlut              14
# define TxtBl               15
// blikajc poped
# define TxtBlikat           0x80

built_in(109) int  GrtiCetzec( char* prompt, char* retezec, int pocet_znaku, int edituj_obsah, int barvy );
built_in(110) int  GrtiIslo( char* prompt, int& cislo, int pocet_znaku, int edituj_obsah, int barvy );
built_in(111) int  GrtiUslo( char* prompt, unsigned& cislo, int pocet_znaku, int edituj_obsah, int barvy );
built_in(112) int  GrtiLslo( char* prompt, long& cislo, int pocet_znaku, int edituj_obsah, int barvy );
built_in(113) int  GrtiDslo( char* prompt, double& cislo, int pocet_znaku, int edituj_obsah, int barvy );
built_in(114) int  GrtiZnak( char* prompt, char& znak, int edituj_obsah, int barvy );

built_in(115) int  GrNastavBarvy( int barvy );
built_in(116) int  GrBarvy();
built_in(117) int  GrBarvaPoped();
built_in(118) int  GrBarvaPozad();
built_in(119) void GrPiNovdek();

built_in(120) char* strcpy( char* etzec1, char* etzec2 );
built_in(121) char* strcpyn( char* etzec1, char* etzec2, unsigned n );
built_in(122) char* strcat( char* etzec1, char* etzec2 );
built_in(123) char* strcatn( char* etzec1, char* etzec2, unsigned n );
built_in(124) char* strchr( char* etzec, int Znak );
built_in(125) char* strrchr( char* etzec, int Znak );
built_in(126) char* strstr( char* etzec1, char* etzec2 );
built_in(127) char* strend( char* etzec );

built_in(128) int   strcmp( char* etzec1, char* etzec2 );
built_in(129) int   strncmp( char* etzec1, char* etzec2, unsigned n );

built_in(130) void* memcpy( void* Kam, void* Odkud, unsigned Poet );
built_in(130) void* memmove( void* Kam, void* Odkud, unsigned Poet );
built_in(131) void* memset( void* Co, int Hodnota, unsigned Poet );

built_in(132) int   TxtNastavBarvy( int barvy );
built_in(133) int   TxtBarvy();
built_in(134) int   TxtBarvaPoped();
built_in(135) int   TxtBarvaPozad();
built_in(136) int   TxtPoziceX();
built_in(137) int   TxtPoziceY();
built_in(138) int   TxttiLslo( long& number );

//////////////////////
//
//  verze 4.00, 5.00
//

// klvesa
built_in(2)   int      gKlvesa;

// peek&poke
built_in( 91) unsigned DataSeg();
built_in( 92) int  peek(  unsigned seg, unsigned ofs );
built_in( 93) int  peekb( unsigned seg, unsigned ofs );
built_in( 94) void poke(  unsigned seg, unsigned ofs, int hodnota16);
built_in( 95) void pokeb( unsigned seg, unsigned ofs, int hodnota8 );

// registry procesoru 80x86
typedef struct {
  unsigned AX, BX, CX, DX, BP, SI, DI, DS, ES, Flags;
  } TypRegistry;

// registr pznak (Flags)
# define FlagCarry     (1<<0)  // carry
# define FlagParity    (1<<2)  // parity
# define FlagAuxCarry  (1<<4)  // aux carry
# define FlagZero      (1<<6)  // zero
# define FlagSign      (1<<7)  // sign
# define FlagTrap      (1<<8)  // trap
# define FlagInterrupt (1<<9)  // interrupt
# define FlagDirection (1<<10) // direction
# define FlagOverflow  (1<<11) // overflow

// sw peruen (interrupt)
built_in( 96) void intr( int intr_cislo, TypRegistry& registry );

// prce s pamt
built_in( 97) void fmemcpy( unsigned cil_seg,   unsigned cil_ofs,
                            unsigned zdroj_seg, unsigned zdroj_ofs,
                            unsigned Velikost   );
built_in( 97) void fmemmove( unsigned cil_seg,   unsigned cil_ofs,
                             unsigned zdroj_seg, unsigned zdroj_ofs,
                             unsigned Velikost   );
built_in( 98) void fmemset( unsigned cil_seg,   unsigned cil_ofs,
                            int hodnota8, unsigned Velikost );

// komunikace po COM lince
built_in(100) int COMPipoj( unsigned char COM, unsigned char rychlost );
built_in(101) int COMOdpoj( unsigned char COM );
built_in(102) int COMti( unsigned char COM );
built_in(103) int COMPi( unsigned char COM, unsigned char hodnota );

# define COM110Bd	    0
# define COM150Bd	    1
# define COM300Bd	    2
# define COM600Bd	    3
# define COM1200Bd    4
# define COM2400Bd    5
# define COM4800Bd    6
# define COM9600Bd    7
# define COM19200Bd   8
# define COM38400Bd   9
# define COM115200Bd 10

// prce s etzci - dokonen
built_in(139) int   stricmp( char* s1, char* s2 );
built_in(140) int   strnicmp( char* s1, char* s2, unsigned delka );
built_in(141) char* strlwr( char* s );
built_in(142) char* strupr( char* s );

built_in(143) int czchrupr( int znak );
built_in(144) int czchrlwr( int znak );
built_in(145) int czchrplain( int znak );

built_in(146) char* czstrupr( char* retezec );
built_in(147) char* czstrlwr( char* retezec );
built_in(148) char* czstrplain( char* retezec );

built_in(149) int czstrcmp( char* ret1, char* ret2 );
built_in(150) int czstricmp( char* ret1, char* ret2 );
built_in(151) int czstriicmp( char* ret1, char* ret2 );

built_in(153) long   StrNaLslo( char* retezec, int* chyba );
built_in(154) double StrNaDslo( char* retezec, int* chyba );

built_in(155) char* LsloNaetzec( char* retezec, long cislo, int delka );
built_in(156) char* DsloNaetzec( char* retezec, double cislo,
                                     int delka, int desetinna_delka );

built_in(159) int PrchodnostPedmtu( TypPedmt predm );
built_in(160) int NastavPrchodnostPedmtu( TypPedmt predm,
                                                  int pruch );
built_in(161) TypPedmt NatiPedmty( TypPedmt PrvnPedmt, int Poet );
built_in(162) int  NastavJmnoBankyPedmt( char* jmeno_souboru );
built_in(163) void GrNastavPaletu( TypPedmt cislo_predmetu );

built_in(332) void NastavZatekAnimaceBaltazara( TypPedmt prvn );

built_in(164) int TransparentnBarvaPedmtu( TypPedmt predm );
built_in(165) int NastavTransparentnBarvuPedmtu( TypPedmt predm, int barva );

built_in(166) long RychlostCPU();
built_in(333) void ekejNaVR();
built_in(167) int  TxtdkovEditor( string& ret, unsigned max_znaku,
                                     unsigned sirka, int pozice, int* ukonceni );
built_in(168) int  NastavViditelnostBaltazara( int Viditelnost );

// textov reim
# define TxtMdB40x25 0x001
# define TxtMdB40x25  0x002
# define TxtMdB80x25 0x003
# define TxtMdB80x25  0x004
# define TxtMdMono    0x005
# define TxtMdB80x50 0x103
# define TxtMdB80x50  0x104

built_in(170) int TxtNastavMd( int mod );
built_in(313) int TxtMd();

# define TxtKurzorNeviditeln 0
# define TxtKurzorMal        1
# define TxtKurzorVelk       2

built_in(171) int TxtNastavTvarKurzoru( int tvar );
built_in(172) int TxtMaxX();
built_in(173) int TxtMaxY();
built_in(306) int TxttiSetzec( string& etzec );

// grafika
# define GrkaPolka  39
# define GrVkaPolka  29

built_in(175) void GrNastavPoziciRel( int x, int y );
built_in(176) int  GrNastavVstup( int vystup, ...);

# define GrVstupOknko               0
# define GrVstupOkno                 1
# define GrVstupPlocha               2
# define GrVstupUivatelsk1         3
# define GrVstupUivatelsk2         4
# define GrVstupUivatelsk3         5
# define GrVstupUivatelsk4         6
# define GrVstupUivatelskNastaven 8

# define GrVstupOknkoX 229
# define GrVstupOknkoY 310
# define GrVstupOknoX    25
# define GrVstupOknoY    11

typedef unsigned char TypGrVplVzorek[8];

built_in(177) void GrNastavVpl( int druh, ...);

# define GrVplPln   0
# define GrVplVzorek 1

built_in(178) void GrNastavLinku( int druh, ...);

# define GrLinkaPln   1
# define GrLinkaVzorek 2
# define GrLinkaTenk  4
# define GrLinkaTlust 8

# define GrLinkaZpsobKreslenNormln 0x10
# define GrLinkaZpsobKreslenXor      0x20
# define GrLinkaZpsobKreslenOr       0x30
# define GrLinkaZpsobKreslenAnd      0x40
# define GrLinkaZpsobKreslenNot      0x50

built_in(179) int GrNastavText( int druh );

# define GrTextSPozadm  0
# define GrTextBezPozad 1

built_in(180) void GrKresliObdlnk( int X1, int Y1, int X2, int Y2 );
built_in(181) void GrKresliVyplnnObdlnk( int X1, int Y1, int X2, int Y2 );
built_in(182) void GrKresliElipsu( int x, int y,
                                   double pocatecni_uhel, // radiny
                                   double koncovy_uhel,   // radiny
                                   unsigned x_polomer,
                                   unsigned y_polomer );
built_in(183) void GrKresliLinku( int X1, int Y1, int X2, int Y2 );
built_in(184) void GrKresliLinkuDo( int x, int y );
built_in(185) void GrKresliLinkuRel( int DX, int dy );
built_in(186) void GrKresliMnohohelnk( unsigned pocet_bodu,
                                         int X1, int Y1, ...);
built_in(187) int  GrKresliVyplnnMnohohelnk( unsigned pocet_bodu,
                                                 int X1, int Y1, ...);
built_in(188) int  GrVyplPlochu( int x, int y, int barva_okraje );
built_in(189) int  GrBarvaBodu( int x, int y );
built_in(190) void GrKresliBod( int x, int y, int barva );
built_in(191) int  GrKresliPedmt( TypPedmt predm, int transparentn,
                                    int x, int y );
built_in(316) int  GrKresliPedmty( TypPedmt predm, int transparentn,
                                     int x, int y, int , int v );
built_in(192) int  GrNastavObrazPedmtu( TypPedmt predm,
                                          int x, int y,
                                          int pouze_z_plochy );
built_in(317) int  GrNastavObrazPedmt( TypPedmt predm,
                                          int x, int y,
                                          int , int v,
                                          int pouze_z_plochy );
built_in(329) int  GrNatiBMP( int x, int y, char* JmnoSouboru,
                               int BMPx, int BMPy, int BMPw, int BMPh,
                               int BMPPaleta );
built_in(330) int  GrUloBMP( int x, int y, int w, int h, char* JmnoSouboru );

typedef struct {
  long Velikost;
  long ka;
  long Vka;
  unsigned PoetRovin;
  unsigned BityNaBod;
  long Komprese;
  long VelikostObrzku;
  long XBodyNaMetr, YBodyNaMetr;
  long PoetPouitchBarev;
  long PoetDleitchBarev;
  } TypBMPInfo;

built_in(331) int  GrNatiBMPInfo( char* JmnoSouboru, TypBMPInfo& BMPInfo );

typedef struct {
  int X, Y, X1, Y1, X2, Y2;
  } TypGrPoziceOblouku;

built_in(193) void GrPoziceOblouku( TypGrPoziceOblouku& obl_poz );

built_in(194) int  GrMaxX();
built_in(195) int  GrMaxY();

# define GrMdEGA           1
# define GrMdVGA           2
# define GrMdVESA800x600   3
# define GrMdVESA1024x768  4
# define GrMdVESA1280x1024 5
built_in(196) int  GrNastavMd( int Md );
built_in(312) int  GrMd();
built_in(314) void GrNastavBarvuPalety( int slo, int R, int G, int B );
built_in(326) void GrBarvaPalety( int slo, int& R, int& G, int& B );
built_in(307) int  GrtiSetzec( char* prompt, string& retezec, int pocet_znaku, int edituj_obsah, int barvy );
built_in(320) int  GrdkovEditor( string& retezec, int pocet_znaku, int pozice, int blok_zacatek, int blok_konec, int barvy );

// argumenty a promnn DOSu
built_in(197) int      DOSPoetArgument();
built_in(198) string   DOSArgument( int slo );
built_in(199) string   DOSPromnn( char* Jmno );
built_in(200) unsigned DOSVerze();
built_in(201) int      DOSChyba();

// chyby DOSu
# define DOSChybaSoubor                 2
# define DOSChybaCesta                  3
# define DOSChybaMnohoSoubor           4
# define DOSChybaPstupOdepen         5
# define DOSChybaJednotka              15
# define DOSChybaAktulnAdres       16
# define DOSChybaPejmenovn          17
# define DOSChybaDalPolokaAdrese  18

// disk a adrese ( A=adres, AP=poloka adrese )
built_in(203) long DiskVolnMsto( int jednotka );
built_in(204) long DiskVelikost( int jednotka );

built_in(205) int    AdresVytvo( char* cesta );
built_in(206) int    AdresSma( char* cesta );
built_in(207) string AdresAktuln( int Jednotka );
built_in(208) int    AdresNastavAktuln( char* cesta );

typedef struct {
  char _reserved[21];
  unsigned char Atributy;
  long DatumAas;
  long Velikost;
  char Jmno[13];
  } TypPolokaAdrese;

built_in(209) int  PolokaAdreseNajdiPrvn( char* cesta, unsigned Atributy,
                                              TypPolokaAdrese& apol );
built_in(210) int  PolokaAdreseNajdiDal( TypPolokaAdrese& apol );
built_in(211) void PolokaAdreseDekdujDatumAas( TypPolokaAdrese& apol,
                                                    TypDatum& datum, Typas& cas );

// soubory ( S=soubor )
typedef long TypSoubor;

built_in(213) int    SouborNulujChybu( TypSoubor s );
built_in(221) int    SouborExistuje( char* Jmno );
built_in(214) string SouborAbsolutnCesta( char* Jmno );
built_in(215) string SouborHledej( char* Jmno, char* SeznamAdres );
built_in(216) int    SouborRozdlCestu( char* Cesta,
                                        string& Adres, string& Jmno,
                                        string& Ppona );
// atributy souboru
# define SouborAtributPouzeten 0x01
# define SouborAtributSkryt     0x02
# define SouborAtributSystmov  0x04
# define SouborAtributSvazek     0x08
# define SouborAtributAdres    0x10
# define SouborAtributArchivn   0x20

built_in(217) unsigned SouborAtributy( char* Jmno );
built_in(218) int      SouborNastavAtributy( char* Jmno, unsigned Atributy );

built_in(219) int SouborSma( char* Jmno );
built_in(220) int SouborPejmenuj( char* stare_jmeno, char* nove_jmeno );

// pstup k souboru
# define SouborPstupten 0x01 // ten
# define SouborPstupZpis 0x02 // zpis
// je-li instalovn SHARE.EXE
# define SouborPstupOdepiten       0x30 // odepi ten
# define SouborPstupOdepiZpis       0x20 // odepi zpis
# define SouborPstupOdepitenIZpis 0x10 // odepi ten a zpis
# define SouborPstupPovolVe          0x40 // neodepi nic
# define SouborPstupPrivtn          0x80
// formt
# define SouborPstupTextov 0x100
# define SouborPstupBinrn 0x200

built_in(222) TypSoubor SouborOtevi( char* Jmno, unsigned pristup );
built_in(223) int SouborZapiBuffer( TypSoubor s );
built_in(224) int SouborZavi( TypSoubor& s );
built_in(225) int SouborUzni( TypSoubor s );

built_in(226) unsigned SoubortiBlok( TypSoubor s, void* blok, unsigned Velikost );
built_in(227) int      SoubortiZnak( TypSoubor s );
built_in(228) unsigned SoubortiCetzec( TypSoubor s, char* retezec, unsigned max_delka );
built_in(247) unsigned SoubortiSetzec( TypSoubor s, string& retezec );

built_in(229) unsigned SouborPiBlok( TypSoubor s, void* blok, unsigned Velikost );
built_in(230) int SouborPiZnak( TypSoubor s, char c );
built_in(231) int SouborPietzec( TypSoubor s, char* retezec );

built_in(232) int SouborDataPlatn( TypSoubor s );
built_in(321) int SouborKonec( TypSoubor s );
built_in(233) int SouborChyba( TypSoubor s );

built_in(322) unsigned SouborHandle( TypSoubor s );
built_in(323) int SouborJeZazen( TypSoubor s );
built_in(324) int SouborPipravenProten( TypSoubor s );
built_in(325) int SouborPipravenProZpis( TypSoubor s );

// nastaven pozice souboru odkud
# define SouborPoziceOdZatku  0
# define SouborPoziceOdAktuln 1
# define SouborPoziceOdKonce    2

built_in(234) long SouborPozice( TypSoubor s );
built_in(235) long SouborNastavPozici( TypSoubor s, long pozice, int odkud );
built_in(236) long SouborVelikost( TypSoubor s );

built_in(237) int SouborDatumAas( TypSoubor s, TypDatum& datum, Typas& cas );
built_in(238) int SouborNastavDatumAas( TypSoubor s, TypDatum& datum, Typas& cas );

built_in(239) int SouborPiLslo( TypSoubor s, long d, int delka );
built_in(240) int SouborPiUslo( TypSoubor s, unsigned d, int delka );
built_in(241) int SouborPiDslo( TypSoubor s, double d, int delka, int desetinna_delka );
# define          SouborPiNovdek(s) (SouborPiZnak((s),'\n'))

built_in(242) int SoubortiIslo( TypSoubor s, int& cele_cislo );
built_in(243) int SoubortiUslo( TypSoubor s, unsigned& prirozene_cislo );
built_in(244) int SoubortiDslo( TypSoubor s, double& realne_cislo );
built_in(245) int SoubortiLslo( TypSoubor s, long& velke_cele_cislo );
built_in(246) int SoubortiNovdek( TypSoubor s );

// my
typedef struct {
  char Typ;
  char Tlatka;
  int  X, Y;
  long as;
  } TypMyUdlost;

built_in(0) TypMyUdlost gMyUdlost;

typedef struct {
  int  X, Y;
  char Tlatka;
  } TypMyStav;

// udlost myi - Typ
#define MyUdlostdn                0 // dn udlost nebyla zaznamenna
#define MyUdlostPohyb                1 // pohyb myi - zmna souadnice
#define MyUdlostLevTlDol           2 // lev tlatko dol - dreno
#define MyUdlostLevTlNahoru         4 // lev tlatko nahoru - putno
#define MyUdlostPravTlDol          8 // prav tlatko dol - dreno
#define MyUdlostPravTlNahoru       16 // prav tlatko nahoru - putno
#define MyUdlostProstednTlDol    32 // stedn tlatko dol - dreno
#define MyUdlostProstednTlNahoru  64 // stedn tlatko nahoru - putno

// tlatka myi (maska)
#define MyTlLev       1 // lev tlatko dreno
#define MyTlPrav      2 // prav tlatko dreno
#define MyTlProstedn 4 // stedn tlatko dreno
#define MyTlShift      8 // Shift peaova dren
#define MyTlCtrl      16 // Ctrl peaova dren
#define MyTlAlt       32 // Alt peaova dren

built_in(248) int MyZatekObsluhy();
built_in(249) void MyKonecObsluhy();
built_in(250) void MyZobrazKurzor();
built_in(251) void MySchovejKurzor();
built_in(252) void MyStav( TypMyStav& stav );
built_in(253) void MytiUdlost( TypMyUdlost& udalost );
built_in(254) void MyNastavPozici( int x, int y );
built_in(255) void MyNastavRozsah( int minx, int miny, int maxx, int maxy );
built_in(256) void MyNastavGrKurzor( TypPedmt pedmt );
built_in(318) void MyZmGrKurzor( TypPedmt pedmt );
built_in(257) void MyNastavTxtKurzor( unsigned and_mask, unsigned xor_mask );
built_in(319) void MyZmTxtKurzor( unsigned and_mask, unsigned xor_mask );
built_in(258) void MyVyprzdniFrontuUdlost();


// obsluha klvesnice
typedef struct {
  char Typ;
  char Klvesa;
  unsigned Peaovae;
  long as;
  } TypKlUdlost;

built_in(1) TypKlUdlost gKlUdlost;

// udlost klvesnice - Typ
#define KlUdlostdn     0 // dn udlost nebyla zaznamenna
#define KlUdlostKlDol    1 // klvesa dol - drena
#define KlUdlostKlNahoru  2 // klvesa nahoru - putna

// peaovae klvesnice
#define KlPeaovaPravShift  (1<< 0) // prav Shift stisknuta
#define KlPeaovaLevShift   (1<< 1) // lev Shift stisknuta
#define KlPeaovaShift       (KlPeaovaPravShift|KlPeaovaLevShift) // libovoln Shift
#define KlPeaovaCtrl        (1<< 2) // libovoln Ctrl stisknuta
#define KlPeaovaAlt         (1<< 3) // libovoln Alt stisknuta
#define KlPeaovaLevCtrl    (1<< 8) // lev Ctrl stisknuta
#define KlPeaovaLevAlt     (1<< 9) // lev Alt stisknuta
#define KlPeaovaSysReq      (1<<10) // SysReq stisknuta
#define KlPeaovaScrollLock  (1<<12) // ScrollLock stisknuta
#define KlPeaovaNumLock     (1<<13) // NumLock stisknuta
#define KlPeaovaCapsLock    (1<<14) // CapsLock stisknuta
#define KlPeaovaInsert      (1<<15) // Insert stisknuta

#define KlPeaovaStavScrollLock (1<< 4) // pepna ScrollLock zapnut
#define KlPeaovaStavNumLock    (1<< 5) // pepna NumLock zapnut
#define KlPeaovaStavCapsLock   (1<< 6) // pepna CapsLock zapnut
#define KlPeaovaStavInsert     (1<< 7) // pepna Insert zapnut

built_in(260) void KlZatekObsluhy( int AutoOpakovn );
built_in(261) void KlKonecObsluhy();
built_in(262) int  KlKlvesaStisknuta( int Klvesa );
built_in(263) unsigned KlPeaovae();
built_in(264) void KltiUdlost( TypKlUdlost& udalost );
built_in(265) void KlVyprzdniFrontuUdlost();

// pvodn klvesnice XT/AT - 83 klves
# define KlScanEsc                      1
# define KlScan1                        2
# define KlScan2                        3
# define KlScan3                        4
# define KlScan4                        5
# define KlScan5                        6
# define KlScan6                        7
# define KlScan7                        8
# define KlScan8                        9
# define KlScan9                       10
# define KlScan0                       11
# define KlScanMnus                   12
# define KlScanRovntko                13
# define KlScanBackspace               14
# define KlScanTab                     15
# define KlScanQ                       16
# define KlScanW                       17
# define KlScanE                       18
# define KlScanR                       19
# define KlScanT                       20
# define KlScanY                       21
# define KlScanU                       22
# define KlScanI                       23
# define KlScanO                       24
# define KlScanP                       25
# define KlScanLevHranatZvorka      26
# define KlScanPravHranatZvorka     27
# define KlScanEnter                   28
# define KlScanLevCtrl                29
# define KlScanA                       30
# define KlScanS                       31
# define KlScanD                       32
# define KlScanF                       33
# define KlScanG                       34
# define KlScanH                       35
# define KlScanJ                       36
# define KlScanK                       37
# define KlScanL                       38
# define KlScanStednk                39
# define KlScanApostrof                40
# define KlScanVlnovka                 41
# define KlScanLevShift               42
# define KlScanZptnLomtko           43
# define KlScanZ                       44
# define KlScanX                       45
# define KlScanC                       46
# define KlScanV                       47
# define KlScanB                       48
# define KlScanN                       49
# define KlScanM                       50
# define KlScanrka                   51
# define KlScanTeka                   52
# define KlScanLomtko                 53
# define KlScanPravShift              54
# define KlScanHvzdika               55
# define KlScanLevAlt                 56
# define KlScanMezernk                57
# define KlScanCapsLock                58
# define KlScanF1                      59
# define KlScanF2                      60
# define KlScanF3                      61
# define KlScanF4                      62
# define KlScanF5                      63
# define KlScanF6                      64
# define KlScanF7                      65
# define KlScanF8                      66
# define KlScanF9                      67
# define KlScanF10                     68
# define KlScanNumLock                 69
# define KlScanScrollLock              70
# define KlScanNum7                    71
# define KlScanNum8                    72
# define KlScanNum9                    73
# define KlScanNumMnus                74
# define KlScanNum4                    75
# define KlScanNum5                    76
# define KlScanNum6                    77
# define KlScanNumPlus                 78
# define KlScanNum1                    79
# define KlScanNum2                    80
# define KlScanNum3                    81
# define KlScanNum0                    82
# define KlScanNumTeka                83
//  84 klvesov AT
# define KlScanSysRq                   84
// 101 klvesov AT
# define KlScanF11                     87
# define KlScanF12                     88
// specifick pro Baltazara
# define KlScanPravAlt                89
# define KlScanPravCtrl               90
# define KlScanDoleva                  91
# define KlScanDoprava                 92
# define KlScanNahoru                  93
# define KlScanDol                    94
# define KlScanIns                     95
# define KlScanDel                     96
# define KlScanHome                    97
# define KlScanEnd                     98
# define KlScanPageUp                  99
# define KlScanPageDown               100
# define KlScanNumEnter               101
# define KlScanNumLomtko             102

// animovan objekty
typedef long TypAnimPedmt;

built_in(267) TypAnimPedmt AnimPedmtVytvo( TypPedmt prvn_pedmt,
                               unsigned poet_pedmt,
                               int md_animace, int transparentn );

built_in(268) void AnimPedmtZru( TypAnimPedmt& objekt );
built_in(269) void AnimPedmtAnimuj( TypAnimPedmt objekt,
                     int x, int y, int slo_fze );
built_in(270) void AnimPedmtSchovej( TypAnimPedmt objekt );
built_in(271) int  AnimNastavGrVstup( int vstup );
built_in(272) int  AnimPedmtPoziceX( TypAnimPedmt objekt );
built_in(273) int  AnimPedmtPoziceY( TypAnimPedmt objekt );
built_in(274) int  AnimPedmtFze( TypAnimPedmt objekt );
built_in(275) void AnimPedmtDejPed( TypAnimPedmt objekt,
                                     TypAnimPedmt ped_co );
built_in(276) void AnimPedmtDejZa( TypAnimPedmt objekt, TypAnimPedmt za_co );
built_in(277) int  AnimPedmtKolidujeS( TypAnimPedmt objekt, TypAnimPedmt s_kterm );
built_in(278) int  AnimPedmtZobrazen( TypAnimPedmt objekt );

// heap
built_in(280) void* malloc( unsigned Velikost );
built_in(281) void  free( void* pam؜ );
built_in(282) void* realloc( void* pam؜, unsigned nov_velikost );

built_in(280) void* HromadaAlokujPam؜( unsigned Velikost );
built_in(281) void  HromadaUvolniPam؜( void* pam؜ );
built_in(282) void* HromadaZnovuAlokujPam؜( void* pam؜, unsigned nov_velikost );

built_in(283) unsigned HromadaVolnPam؜();
built_in(284) unsigned HromadaVolnSouvislPam؜();

// string
built_in(285) unsigned StrVelikost( string& Str );
built_in(286) string&  StrNastavVelikost( string& Str, unsigned Velikost );
built_in(  2) unsigned StrDlka( char* Str );

built_in(287) string&  StrVlo( string& Str, string Str2, unsigned Pozice );
built_in(288) string&  StrSma( string& Str, unsigned Pozice, unsigned Poet );
built_in(327) int      StrSmaPodetzec( string& Str, unsigned Pozice, char* SubStr );
built_in(328) unsigned StrPozicePodetzce( char* Str, unsigned Pozice, char* SubStr );
built_in(289) string   StrKopie( char* Str, unsigned Pozice, unsigned Poet );
built_in(290) string   StrLslo( long slo, int Dlka );
built_in(291) string   StrDslo( double slo, int Dlka, int DesetinnDlka );

built_in(292) string&  StrVytvo( string& Str );
built_in(293) string&  StrZru( string& Str );

built_in(308) string   StrNaMal( char* Str );
built_in(309) string   StrNaVelk( char* Str );
built_in(310) string   StrBezDiakritiky( char* Str );
built_in(311) string   StrZnak( int Znak, unsigned Poet );

built_in(294) string   ProgramCesta();

// joystick
typedef struct TypJoystickStav1 {
  int  X, Y;
  char Tlatko[2];
  } TypJoystickStav[2];

built_in(295) void Joystickti( struct TypJoystickStav1* Joystick );

built_in(296) long SystmovTikot();

// datum
built_in(297) int       DatumPlatn( TypDatum& Datum );
built_in(298) TypDatum& DatumPosu( TypDatum& Datum, int Roky, int Msce, long Dny );
built_in(299) long      DatumRozdl( TypDatum& Datum1, TypDatum& Datum2 );
built_in(300) TypDatum& DatumNastavDenTdne( TypDatum& Datum );
built_in(301) int       asPlatn( Typas& as );
built_in(302) Typas&   asPosu( Typas& as, long Hodiny, long Minuty, long Sekundy, long Setiny );
built_in(303) long      asRozdl( Typas& as1, Typas& as2 );
built_in(304) void      DatumasPosu( TypDatum& Datum, Typas& as,
                          int Roky, int Msce, long Dny,
                          long Hodiny, long Minuty, long Sekundy, long Setiny );
built_in(305) void      DatumasRozdl( TypDatum& Datum1, Typas& as1,
                          TypDatum& Datum2, Typas& as2,
                          long& Dny, long& Setiny );

# define __BALTAZAR__
# endif
